package com.usky.iot.mapper;

import com.usky.common.mybatis.core.CrudMapper;
import com.usky.common.security.utils.SecurityUtils;
import com.usky.iot.domain.DmpDeviceInfo;
import com.usky.iot.domain.DmpDeviceStatus;
import com.usky.iot.service.vo.DmpDataOverviewVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;


/**
 * <p>
 * 设备状态表 Mapper 接口
 * </p>
 *
 * @author ya
 * @since 2022-10-08
 */
@Repository
public interface DmpDeviceStatusMapper extends CrudMapper<DmpDeviceStatus> {


    List<DmpDataOverviewVO> getDeviceStatusCollect(@Param("productId") Integer productId,
                                                   @Param("startTime") Date startTime,
                                                   @Param("endTime") Date endTime,
                                                   @Param("tenantId") Integer tenantId);


    DmpDataOverviewVO getAllCollect(@Param("productId") Integer productId,
                                             @Param("startTime") Date startTime,
                                             @Param("endTime") Date endTime,
                                    @Param("tenantId") Integer tenantId);


    List<DmpDataOverviewVO> getMonthHyCollect(@Param("productId") Integer productId,
                                               @Param("startTime") Date startTime,
                                               @Param("endTime") Date endTime,
                                              @Param("tenantId") Integer tenantId);

    DmpDataOverviewVO getAllMonthHyCollect(@Param("productId") Integer productId,
                                            @Param("startTime") Date startTime,
                                            @Param("endTime") Date endTime,
                                           @Param("tenantId") Integer tenantId);


}
